<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcMeshSelect Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcMeshSelect Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcMeshSelect" --><!-- doxytag: inherits="iBase" -->
<p>This is a property class for selecting meshes.  
 <a href="structiPcMeshSelect.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="meshsel_8h_source.html">propclass/meshsel.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcMeshSelect:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcMeshSelect.png" usemap="#iPcMeshSelect_map" alt=""/>
  <map id="iPcMeshSelect_map" name="iPcMeshSelect_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,96,24"/>
</map>
 </div></div>

<p><a href="structiPcMeshSelect-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a003a8c1980e045a03c11dcc51a3201e2">AddMeshSelectListener</a> (<a class="el" href="structiPcMeshSelectListener.html">iPcMeshSelectListener</a> *listener)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a listener to listen to mouse selection.  <a href="#a003a8c1980e045a03c11dcc51a3201e2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#afe57fc169f00bd7b637040caee8029e3">GetDragPlaneNormal</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;drag_normal, bool &amp;camera_space) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the drag normal and camera space flag.  <a href="#afe57fc169f00bd7b637040caee8029e3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a68cce0df3e96c93f7d1cdd13b3aaf7f3">GetMaxSelectionDistance</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the maximum distance to use for mesh selection.  <a href="#a68cce0df3e96c93f7d1cdd13b3aaf7f3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#aa8f6be714ce22d723e7718deab7d1a9f">GetMouseButtons</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the bit-mask for the supported buttons.  <a href="#aa8f6be714ce22d723e7718deab7d1a9f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#aec066bb5a01a2ba88c8e52a7fef3561a">HasDragMode</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get value of drag mode.  <a href="#aec066bb5a01a2ba88c8e52a7fef3561a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a3a9ba9328a5e0f359ee30160ef1cd97a">HasFollowAlwaysMode</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of follow always mode.  <a href="#a3a9ba9328a5e0f359ee30160ef1cd97a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a81e324a5cff0ebd3fb18573cf812d298">HasFollowMode</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of follow mode.  <a href="#a81e324a5cff0ebd3fb18573cf812d298"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a5c36f2830df3af7f88b6954afb0e8d96">HasGlobalSelection</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get value of global/local selection.  <a href="#a5c36f2830df3af7f88b6954afb0e8d96"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a7e0a7edf84513530c8a412087f89c5f7">HasSenddownEvent</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of send down events.  <a href="#a7e0a7edf84513530c8a412087f89c5f7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a50fa2c873d138e4cf121a5c6748a7918">HasSendmoveEvent</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of send move events.  <a href="#a50fa2c873d138e4cf121a5c6748a7918"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a2e5ff3f6d29e8e23293b52c7792ac38d">HasSendupEvent</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the value of send up events.  <a href="#a2e5ff3f6d29e8e23293b52c7792ac38d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a506b74d5aa4840565b87250e0950b3bd">RemoveMeshSelectListener</a> (<a class="el" href="structiPcMeshSelectListener.html">iPcMeshSelectListener</a> *listener)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a mesh selection listener.  <a href="#a506b74d5aa4840565b87250e0950b3bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a3851251af34515ce15b4e8e7ca0a0a9e">SetCamera</a> (<a class="el" href="structiPcCamera.html">iPcCamera</a> *camera)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the camera to use for mesh selection.  <a href="#a3851251af34515ce15b4e8e7ca0a0a9e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a38b1b6bafad0d62d0123dafb1020e3cc">SetDragMode</a> (bool drag)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then it is possible to drag the selected object.  <a href="#a38b1b6bafad0d62d0123dafb1020e3cc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a8641509a8eb0ec284432408da301201e">SetDragPlaneNormal</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;drag_normal, bool camera_space)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the normal of the plane on which the dragged object will move.  <a href="#a8641509a8eb0ec284432408da301201e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#aa5cc6a32f28004b105c667ade955a609">SetFollowAlwaysMode</a> (bool followalways)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then also send move messages when the entity is not selected but the mouse is positioned on top of the entity.  <a href="#aa5cc6a32f28004b105c667ade955a609"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a02fa1e98f777b0be713769f88bf39d8e">SetFollowMode</a> (bool follow)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then follow the mouse so that up/down events come through immediatelly when the mouse leaves the object (even if mouse up has not yet happened).  <a href="#a02fa1e98f777b0be713769f88bf39d8e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a5839931c030d52b65922f0927afbe24d">SetGlobalSelection</a> (bool glob)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set global/local selection.  <a href="#a5839931c030d52b65922f0927afbe24d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#ac3da18605c5c9281c7db370182579242">SetMaxSelectionDistance</a> (float distance)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the maximum distance to use for mesh selection.  <a href="#ac3da18605c5c9281c7db370182579242"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a06a14ad288a68cc4b87519540e0514ac">SetMouseButtons</a> (int buttons)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate (with a bit-mask) for which buttons this mesh selector will work.  <a href="#a06a14ad288a68cc4b87519540e0514ac"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a92a6f866a393bdd221c91c2016c9d2f5">SetMouseButtons</a> (const char *buttons)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate (with a string) for which buttons this mesh selector will work.  <a href="#a92a6f866a393bdd221c91c2016c9d2f5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a5f20d1fcdc70c5db28549bbfa48a838c">SetSenddownEvent</a> (bool sd)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then send mouse-down events (message 'selectmesh_down').  <a href="#a5f20d1fcdc70c5db28549bbfa48a838c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a6fee341f0bd1c14877587d28cf3cbbf1">SetSendmoveEvent</a> (bool mov)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then also send messages on mouse move (only between mouse-down and mouse-up (message 'selectmesh_move').  <a href="#a6fee341f0bd1c14877587d28cf3cbbf1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMeshSelect.html#a1c3a615b4d567a95823cdf453fbaf318">SetSendupEvent</a> (bool su)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">If true then send mouse-up events (message 'selectmesh_up').  <a href="#a1c3a615b4d567a95823cdf453fbaf318"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a property class for selecting meshes. </p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.mesh.select.down' (old 'pcmeshsel_down'): mesh is selected (x,y,button,entity)</li>
<li>'cel.mesh.select.up' (old 'pcmeshsel_up'): mesh is unselected (x,y,button,entity)</li>
<li>'cel.mesh.select.move' (old 'pcmeshsel_move'): mesh is moved (x,y,button,entity)</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.mesh.select.action.' if you want to access this action through a message):</p>
<ul>
<li>SetCamera: parameters 'entity' (string).</li>
<li>SetMouseButtons: parameters 'buttons' (string or long). In case of string it should be a string with 'l', 'm', or 'r' (or a combination).</li>
<li>SetDragPlaneNormal: parameters 'normal' (vector3), 'camera' (bool).</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>global (bool, read/write): global selection, default false.</li>
<li>follow (bool, read/write): follow mode, default false.</li>
<li>followalways (bool, read/write): follow always mode, default false.</li>
<li>drag (bool, read/write): drag mode, default false.</li>
<li>sendmove (bool, read/write): send move events, default false.</li>
<li>sendup (bool, read/write): send up events, default true.</li>
<li>senddown (bool, read/write): send down events, default true.</li>
<li>maxdistance (float, read/write): maximum selection distance, default 100000. </li>
</ul>

<p>Definition at line <a class="el" href="meshsel_8h_source.html#l00089">89</a> of file <a class="el" href="meshsel_8h_source.html">meshsel.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a003a8c1980e045a03c11dcc51a3201e2"></a><!-- doxytag: member="iPcMeshSelect::AddMeshSelectListener" ref="a003a8c1980e045a03c11dcc51a3201e2" args="(iPcMeshSelectListener *listener)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a003a8c1980e045a03c11dcc51a3201e2">iPcMeshSelect::AddMeshSelectListener</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMeshSelectListener.html">iPcMeshSelectListener</a> *&#160;</td>
          <td class="paramname"><em>listener</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a listener to listen to mouse selection. </p>
<p>These listeners are called right before the behaviour is called. </p>

</div>
</div>
<a class="anchor" id="afe57fc169f00bd7b637040caee8029e3"></a><!-- doxytag: member="iPcMeshSelect::GetDragPlaneNormal" ref="afe57fc169f00bd7b637040caee8029e3" args="(csVector3 &amp;drag_normal, bool &amp;camera_space) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#afe57fc169f00bd7b637040caee8029e3">iPcMeshSelect::GetDragPlaneNormal</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>drag_normal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &amp;&#160;</td>
          <td class="paramname"><em>camera_space</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the drag normal and camera space flag. </p>

</div>
</div>
<a class="anchor" id="a68cce0df3e96c93f7d1cdd13b3aaf7f3"></a><!-- doxytag: member="iPcMeshSelect::GetMaxSelectionDistance" ref="a68cce0df3e96c93f7d1cdd13b3aaf7f3" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcMeshSelect.html#a68cce0df3e96c93f7d1cdd13b3aaf7f3">iPcMeshSelect::GetMaxSelectionDistance</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the maximum distance to use for mesh selection. </p>

</div>
</div>
<a class="anchor" id="aa8f6be714ce22d723e7718deab7d1a9f"></a><!-- doxytag: member="iPcMeshSelect::GetMouseButtons" ref="aa8f6be714ce22d723e7718deab7d1a9f" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual int <a class="el" href="structiPcMeshSelect.html#aa8f6be714ce22d723e7718deab7d1a9f">iPcMeshSelect::GetMouseButtons</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the bit-mask for the supported buttons. </p>

</div>
</div>
<a class="anchor" id="aec066bb5a01a2ba88c8e52a7fef3561a"></a><!-- doxytag: member="iPcMeshSelect::HasDragMode" ref="aec066bb5a01a2ba88c8e52a7fef3561a" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#aec066bb5a01a2ba88c8e52a7fef3561a">iPcMeshSelect::HasDragMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get value of drag mode. </p>

</div>
</div>
<a class="anchor" id="a3a9ba9328a5e0f359ee30160ef1cd97a"></a><!-- doxytag: member="iPcMeshSelect::HasFollowAlwaysMode" ref="a3a9ba9328a5e0f359ee30160ef1cd97a" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a3a9ba9328a5e0f359ee30160ef1cd97a">iPcMeshSelect::HasFollowAlwaysMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of follow always mode. </p>

</div>
</div>
<a class="anchor" id="a81e324a5cff0ebd3fb18573cf812d298"></a><!-- doxytag: member="iPcMeshSelect::HasFollowMode" ref="a81e324a5cff0ebd3fb18573cf812d298" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a81e324a5cff0ebd3fb18573cf812d298">iPcMeshSelect::HasFollowMode</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of follow mode. </p>

</div>
</div>
<a class="anchor" id="a5c36f2830df3af7f88b6954afb0e8d96"></a><!-- doxytag: member="iPcMeshSelect::HasGlobalSelection" ref="a5c36f2830df3af7f88b6954afb0e8d96" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a5c36f2830df3af7f88b6954afb0e8d96">iPcMeshSelect::HasGlobalSelection</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get value of global/local selection. </p>

</div>
</div>
<a class="anchor" id="a7e0a7edf84513530c8a412087f89c5f7"></a><!-- doxytag: member="iPcMeshSelect::HasSenddownEvent" ref="a7e0a7edf84513530c8a412087f89c5f7" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a7e0a7edf84513530c8a412087f89c5f7">iPcMeshSelect::HasSenddownEvent</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of send down events. </p>

</div>
</div>
<a class="anchor" id="a50fa2c873d138e4cf121a5c6748a7918"></a><!-- doxytag: member="iPcMeshSelect::HasSendmoveEvent" ref="a50fa2c873d138e4cf121a5c6748a7918" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a50fa2c873d138e4cf121a5c6748a7918">iPcMeshSelect::HasSendmoveEvent</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of send move events. </p>

</div>
</div>
<a class="anchor" id="a2e5ff3f6d29e8e23293b52c7792ac38d"></a><!-- doxytag: member="iPcMeshSelect::HasSendupEvent" ref="a2e5ff3f6d29e8e23293b52c7792ac38d" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcMeshSelect.html#a2e5ff3f6d29e8e23293b52c7792ac38d">iPcMeshSelect::HasSendupEvent</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of send up events. </p>

</div>
</div>
<a class="anchor" id="a506b74d5aa4840565b87250e0950b3bd"></a><!-- doxytag: member="iPcMeshSelect::RemoveMeshSelectListener" ref="a506b74d5aa4840565b87250e0950b3bd" args="(iPcMeshSelectListener *listener)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a506b74d5aa4840565b87250e0950b3bd">iPcMeshSelect::RemoveMeshSelectListener</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMeshSelectListener.html">iPcMeshSelectListener</a> *&#160;</td>
          <td class="paramname"><em>listener</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a mesh selection listener. </p>

</div>
</div>
<a class="anchor" id="a3851251af34515ce15b4e8e7ca0a0a9e"></a><!-- doxytag: member="iPcMeshSelect::SetCamera" ref="a3851251af34515ce15b4e8e7ca0a0a9e" args="(iPcCamera *camera)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a3851251af34515ce15b4e8e7ca0a0a9e">iPcMeshSelect::SetCamera</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcCamera.html">iPcCamera</a> *&#160;</td>
          <td class="paramname"><em>camera</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the camera to use for mesh selection. </p>

</div>
</div>
<a class="anchor" id="a38b1b6bafad0d62d0123dafb1020e3cc"></a><!-- doxytag: member="iPcMeshSelect::SetDragMode" ref="a38b1b6bafad0d62d0123dafb1020e3cc" args="(bool drag)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a38b1b6bafad0d62d0123dafb1020e3cc">iPcMeshSelect::SetDragMode</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>drag</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then it is possible to drag the selected object. </p>
<p>Note that drag mode is usually used in combination with follow mode. (default false). </p>

</div>
</div>
<a class="anchor" id="a8641509a8eb0ec284432408da301201e"></a><!-- doxytag: member="iPcMeshSelect::SetDragPlaneNormal" ref="a8641509a8eb0ec284432408da301201e" args="(const csVector3 &amp;drag_normal, bool camera_space)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a8641509a8eb0ec284432408da301201e">iPcMeshSelect::SetDragPlaneNormal</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>drag_normal</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>camera_space</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the normal of the plane on which the dragged object will move. </p>
<p>The actual plane itself will be calculated depending on the current position of the object and that given normal. The normal can be given in camera space or in world space. Default is the 0,0,1 normal in camera space which means that the object will drag according to screen coordinates. </p>

</div>
</div>
<a class="anchor" id="aa5cc6a32f28004b105c667ade955a609"></a><!-- doxytag: member="iPcMeshSelect::SetFollowAlwaysMode" ref="aa5cc6a32f28004b105c667ade955a609" args="(bool followalways)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#aa5cc6a32f28004b105c667ade955a609">iPcMeshSelect::SetFollowAlwaysMode</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>followalways</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then also send move messages when the entity is not selected but the mouse is positioned on top of the entity. </p>
<p>Default false. </p>

</div>
</div>
<a class="anchor" id="a02fa1e98f777b0be713769f88bf39d8e"></a><!-- doxytag: member="iPcMeshSelect::SetFollowMode" ref="a02fa1e98f777b0be713769f88bf39d8e" args="(bool follow)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a02fa1e98f777b0be713769f88bf39d8e">iPcMeshSelect::SetFollowMode</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>follow</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then follow the mouse so that up/down events come through immediatelly when the mouse leaves the object (even if mouse up has not yet happened). </p>
<p>Otherwise mouse up event will arrive only when the mouse is released independent of wether or not the mouse is above the object at release time. Default false. </p>

</div>
</div>
<a class="anchor" id="a5839931c030d52b65922f0927afbe24d"></a><!-- doxytag: member="iPcMeshSelect::SetGlobalSelection" ref="a5839931c030d52b65922f0927afbe24d" args="(bool glob)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a5839931c030d52b65922f0927afbe24d">iPcMeshSelect::SetGlobalSelection</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>glob</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set global/local selection. </p>
<p>With local selection the Behaviour will only get messages when it's own mesh entity is selected (default). With global selection the Behaviour will get messages for selection of all mesh entities. </p>

</div>
</div>
<a class="anchor" id="ac3da18605c5c9281c7db370182579242"></a><!-- doxytag: member="iPcMeshSelect::SetMaxSelectionDistance" ref="ac3da18605c5c9281c7db370182579242" args="(float distance)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#ac3da18605c5c9281c7db370182579242">iPcMeshSelect::SetMaxSelectionDistance</a> </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>distance</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the maximum distance to use for mesh selection. </p>
<p>This is the distance in world units from the camera, into the scene. </p>

</div>
</div>
<a class="anchor" id="a06a14ad288a68cc4b87519540e0514ac"></a><!-- doxytag: member="iPcMeshSelect::SetMouseButtons" ref="a06a14ad288a68cc4b87519540e0514ac" args="(int buttons)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a06a14ad288a68cc4b87519540e0514ac">iPcMeshSelect::SetMouseButtons</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>buttons</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate (with a bit-mask) for which buttons this mesh selector will work. </p>
<p>By default this is the left button. Use a combination of CEL_MOUSE_... flags. </p>

</div>
</div>
<a class="anchor" id="a92a6f866a393bdd221c91c2016c9d2f5"></a><!-- doxytag: member="iPcMeshSelect::SetMouseButtons" ref="a92a6f866a393bdd221c91c2016c9d2f5" args="(const char *buttons)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a06a14ad288a68cc4b87519540e0514ac">iPcMeshSelect::SetMouseButtons</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>buttons</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate (with a string) for which buttons this mesh selector will work. </p>
<p>By default this is the left button. Use a combination of the 'l', 'r', or 'm' characters. </p>

</div>
</div>
<a class="anchor" id="a5f20d1fcdc70c5db28549bbfa48a838c"></a><!-- doxytag: member="iPcMeshSelect::SetSenddownEvent" ref="a5f20d1fcdc70c5db28549bbfa48a838c" args="(bool sd)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a5f20d1fcdc70c5db28549bbfa48a838c">iPcMeshSelect::SetSenddownEvent</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>sd</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then send mouse-down events (message 'selectmesh_down'). </p>
<p>Default true. </p>

</div>
</div>
<a class="anchor" id="a6fee341f0bd1c14877587d28cf3cbbf1"></a><!-- doxytag: member="iPcMeshSelect::SetSendmoveEvent" ref="a6fee341f0bd1c14877587d28cf3cbbf1" args="(bool mov)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a6fee341f0bd1c14877587d28cf3cbbf1">iPcMeshSelect::SetSendmoveEvent</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>mov</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then also send messages on mouse move (only between mouse-down and mouse-up (message 'selectmesh_move'). </p>
<p>Default false. </p>

</div>
</div>
<a class="anchor" id="a1c3a615b4d567a95823cdf453fbaf318"></a><!-- doxytag: member="iPcMeshSelect::SetSendupEvent" ref="a1c3a615b4d567a95823cdf453fbaf318" args="(bool su)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMeshSelect.html#a1c3a615b4d567a95823cdf453fbaf318">iPcMeshSelect::SetSendupEvent</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>su</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>If true then send mouse-up events (message 'selectmesh_up'). </p>
<p>Default true. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="meshsel_8h_source.html">meshsel.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
